
/* www.alex-handfest.de
 *
 * ADC  Analog-Digital Wandler
 */



#include "adc.h"

// Variablen:
unsigned int result = 0;
//Ausgabe als String
char adc[4]     = {'\0'};
char adc_avg[4] = {'\0'};



// Initialisierung des ADC
void ADC_init(void) {
 
	ADC_REF;								// Referenz einstellen
	ADC_F;									// ADC Eingangstakt einstellen
	//ADCSRA |= (1<<ADSC)  | (1<<ADFR);		// ADFR Free Run
	ADCSRA |= (1<<ADEN);					// ADC aktivieren


	// ADCW muss einmal gelesen werden
	ADCSRA |= (1<<ADSC);					// eine ADC-Wandlung 
	while (ADCSRA & (1<<ADSC) ) {}			// auf Abschluss der Konvertierung warten
	result = ADCW;
}


// ADC Einzelmessung
unsigned int ADC_Read( unsigned int channel ) {

	// Kanal waehlen, ohne andere Bits zu beeinfluen
	ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
	ADCSRA |= (1<<ADSC);            	// eine Wandlung "single conversion"
	while (ADCSRA & (1<<ADSC) ) {}  	// auf Abschluss der Konvertierung warten
	return ADCW;                    	// ADC auslesen und zurckgeben
}



// ADC Mehrfachmessung mit Mittelwertbbildung
unsigned int ADC_Read_Avg( unsigned int channel, unsigned int average ) {

	result = 0;

	for (int i = 0; i < average; ++i )
		result += ADC_Read( channel );

	return (uint16_t)( result / average );
}


