
/* www.alex-handfest.de
 *
 * ADC  Analog-Digital Wandler
 * 
 * erstellt: 		28.09.2012
 * letzte nderung: 03.04.2013
 * 
 * ATmega8, 16MHz extern
 * AVR-Studio 4, Optimierungsgrad: O2
 * 
 * Quelle: AVR-GCC-Tutorial  mikrocontroller.net
 */


#ifndef ADC_H
#define ADC_H

#include <avr/io.h>
#include <avr/interrupt.h>



// *********************** EINSTELLUNGEN *************************

// Nach Bedarf ndern oder auskommentieren


// Referenz whlen

//#define ADC_REF		(ADMUX = (0<<REFS1) | (0<<REFS0))	// externe Referenz
#define ADC_REF		(ADMUX = (0<<REFS1) | (1<<REFS0))	// AVcc als Referenz
//#define ADC_REF		(ADMUX = (1<<REFS1) | (1<<REFS0))	// interne 2,56V


// ADC Eingangstakt: 1000000 / 8 = 125 kHz ADC Eingangstakt  
// Soll: 50 - 200 kHz !!!

//#define ADC_F	(ADCSRA |= (0<<ADPS2) | (0<<ADPS1) | (1<<ADPS0))	//   2
//#define ADC_F	(ADCSRA |= (0<<ADPS2) | (1<<ADPS1) | (0<<ADPS0))	//   4
#define ADC_F	(ADCSRA |= (0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0))	//   8
//#define ADC_F	(ADCSRA |= (1<<ADPS2) | (0<<ADPS1) | (0<<ADPS0))	//  16
//#define ADC_F	(ADCSRA |= (1<<ADPS2) | (0<<ADPS1) | (1<<ADPS0))	//  32
//#define ADC_F	(ADCSRA |= (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0))	//  64
//#define ADC_F	(ADCSRA |= (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0))	// 128


// ***************************************************************




// Inizialisierung
// Die ADC Register knnen bei unterschiedlichen Controllern abweichen
void ADC_init (void);


// ADC Einzelmessung
// ADC_Read (Kanal), Kanal 0-7 = ADC0 - 7
unsigned int ADC_Read (unsigned int);


// ADC Mehrfachmessung mit Mittelwertbbildung
// ADC_Read_Avg (Kanal, Anzahl der Messungen)
unsigned int ADC_Read_Avg (unsigned int, unsigned int);


#endif
